//+------------------------------------------------------------------+
//|                                             Steop stochastic.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  DimGray
#property indicator_color2  PaleVioletRed
#property indicator_width2  2
#property indicator_minimum -1
#property indicator_maximum 101

//
//
//
//
//

extern int    UsePrice               = PRICE_CLOSE;
extern int    ATR.Length             = 10;
extern double K.Slow                 =  1;
extern double K.Fast                 =  1;
extern int    Window                 = 256;
extern bool   alertsOn               = false;
extern bool   alertsOnCurrent        = false;
extern bool   alertsMessage          = true;
extern bool   alertsSound            = false;
extern bool   alertsEmail            = false;
extern bool   arrowsVisible          = true;
extern string arrowsIdentifier       = "StepStochArrows";
extern color  arrowsUpColor          = DeepSkyBlue;
extern color  arrowsDnColor          = Red;


//
//
//
//
//

double stoch1[];
double stoch2[];
double atr[];
double trend[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,stoch2);
   SetIndexBuffer(1,stoch1);
   SetIndexBuffer(2,trend);
   SetIndexBuffer(3,atr);
      IndicatorShortName("Step stochastic )"+ATR.Length+","+DoubleToStr(K.Slow,2)+","+DoubleToStr(K.Fast,2)+","+Window+")");
   return(0);
}

//
//
//
//
//

int deinit()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double work[][12];
#define k.SminMin   0
#define k.SmaxMin   1
#define k.SminMid   2
#define k.SmaxMid   3
#define k.SminMax   4
#define k.SmaxMax   5
#define k.TrendMin  6
#define k.TrendMid  7
#define k.TrendMax  8
#define k.linemin   9 
#define k.linemid  10
#define k.linemax  11
#define bigValue   99999999

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,r,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           if (ArrayRange(work,0) != Bars) ArrayResize(work,Bars);

   //
   //
   //
   //
   //

   for(i=limit, r=Bars-limit-1; i>=0; i--,r++)
   {
      double nPrice = iMA(NULL,0,1,0,MODE_SMA,UsePrice,i);  
             atr[i] = iATR(NULL,0,ATR.Length,i);
             if (r<=Window)
             {
                  work[r][k.TrendMin] = 0;
                  work[r][k.TrendMid] = 0;
                  work[r][k.TrendMax] = 0;
                  work[r][k.linemin]  = 0;
                  work[r][k.linemid]  = 0;
                  work[r][k.linemax]  = 0;
                  work[r][k.SminMin]  = bigValue;
                  work[r][k.SmaxMin]  = bigValue;
                  work[r][k.SminMax]  = 0;
                  work[r][k.SmaxMax]  = 0;
                  work[r][k.SminMid]  = 0;
                  work[r][k.SmaxMid]  = 0;
                  continue;
             }

      //
      //
      //
      //
      //
      
         double nATRmax     = atr[ArrayMaximum(atr,Window,i)];
         double nATRmin     = atr[ArrayMinimum(atr,Window,i)];
         double StepSizeMin = (K.Fast * nATRmin);
         double StepSizeMax = (K.Fast * nATRmax);
         double StepSizeMid = (K.Fast * 0.5 * K.Slow * (nATRmax + nATRmin));

            work[r][k.SmaxMin] = nPrice + 2.0 * StepSizeMin;
            work[r][k.SminMin] = nPrice - 2.0 * StepSizeMin;
            work[r][k.SmaxMax] = nPrice + 2.0 * StepSizeMax;
            work[r][k.SminMax] = nPrice - 2.0 * StepSizeMax;
            work[r][k.SmaxMid] = nPrice + 2.0 * StepSizeMid;
            work[r][k.SminMid] = nPrice - 2.0 * StepSizeMid;

            //
            //
            //
            //
            //
         
            double TrendMin = work[r-1][k.TrendMin];
            double TrendMid = work[r-1][k.TrendMid];
            double TrendMax = work[r-1][k.TrendMax];
            double linemin  = work[r-1][k.linemin];
            double linemid  = work[r-1][k.linemid];
            double linemax  = work[r-1][k.linemax];

            //
            //
            //
            //
            //
                        
            if (nPrice > work[r-1][k.SmaxMin]) TrendMin =  1;
            if (nPrice < work[r-1][k.SminMin]) TrendMin = -1;
            if (nPrice > work[r-1][k.SmaxMax]) TrendMax =  1;
            if (nPrice < work[r-1][k.SminMax]) TrendMax = -1;
            if (nPrice > work[r-1][k.SmaxMid]) TrendMid =  1;
            if (nPrice < work[r-1][k.SminMid]) TrendMid = -1;

            if (TrendMin > 0 && work[r][k.SminMin] < work[r-1][k.SminMin]) work[r][k.SminMin] = work[r-1][k.SminMin];
            if (TrendMin < 0 && work[r][k.SmaxMin] > work[r-1][k.SmaxMin]) work[r][k.SmaxMin] = work[r-1][k.SmaxMin];
            if (TrendMax > 0 && work[r][k.SminMax] < work[r-1][k.SminMax]) work[r][k.SminMax] = work[r-1][k.SminMax];
            if (TrendMax < 0 && work[r][k.SmaxMax] > work[r-1][k.SmaxMax]) work[r][k.SmaxMax] = work[r-1][k.SmaxMax];
            if (TrendMid > 0 && work[r][k.SminMid] < work[r-1][k.SminMid]) work[r][k.SminMid] = work[r-1][k.SminMid];
            if (TrendMid < 0 && work[r][k.SmaxMid] > work[r-1][k.SmaxMid]) work[r][k.SmaxMid] = work[r-1][k.SmaxMid];

            if (TrendMin > 0) linemin = work[r][k.SminMin] + StepSizeMin;
            if (TrendMin < 0) linemin = work[r][k.SmaxMin] - StepSizeMin;
            if (TrendMax > 0) linemax = work[r][k.SminMax] + StepSizeMax;
            if (TrendMax < 0) linemax = work[r][k.SmaxMax] - StepSizeMax;
            if (TrendMid > 0) linemid = work[r][k.SminMid] + StepSizeMid;
            if (TrendMid < 0) linemid = work[r][k.SmaxMid] - StepSizeMid;

         //
         //
         //
         //
         //
               
         work[r][k.TrendMin] = TrendMin;
         work[r][k.TrendMid] = TrendMid;
         work[r][k.TrendMax] = TrendMax;
         work[r][k.linemin]  = linemin;
         work[r][k.linemid]  = linemid;
         work[r][k.linemax]  = linemax;
            
         //
         //
         //
         //
         //
         
         double bsmin = linemax - StepSizeMax;
         double bsmax = linemax + StepSizeMax;
         if (bsmax!=bsmin)
         {
            stoch1[i] = ((linemin - bsmin) / (bsmax - bsmin)) * 100.0;
            stoch2[i] = ((linemid - bsmin) / (bsmax - bsmin)) * 100.0;
         }
         else               
         {
            stoch1[i] = 0;
            stoch2[i] = 0;
         }
         trend[i] = trend[i+1];
         if (stoch1[i]>stoch2[i]) trend[i] =  1;
         if (stoch1[i]<stoch2[i]) trend[i] = -1;
         manageArrow(i);
   }
   manageAlerts();
   return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      {
            if (trend[whichBar] ==  1) doAlert(whichBar,"up");
            if (trend[whichBar] == -1) doAlert(whichBar,"down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," step stochastic - trend changed to ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"step stochastic"),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+


void manageArrow(int i)
{
   if (arrowsVisible)
   {
      deleteArrow(Time[i]);
         if (trend[i]!=trend[i+1])
      {
         if (trend[i] ==  1) drawArrow(i,arrowsUpColor,241);
         if (trend[i] == -1) drawArrow(i,arrowsDnColor,242);
      }
     
   }
}               

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode)
{
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = 3.0*iATR(NULL,0,20,i)/4.0;   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (trend[i] ==  1)
               ObjectSet(name,OBJPROP_PRICE1,Low[i]-gap);
         else  ObjectSet(name,OBJPROP_PRICE1,High[i]+gap);
}

//
//
//
//
//

void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}


